using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;
using Decal.Interop.Core;

namespace Decal.Interop.Inject;

[ComImport]
[SuppressUnmanagedCodeSecurity]
[ClassInterface(ClassInterfaceType.None)]
[Guid("918C0333-5714-4C8D-A95C-2C137B76D364")]
public class BrushImageClass : IBrushImage, BrushImage, IImageCache
{
	[DispId(1610678272)]
	public virtual extern int Color
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		get;
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[param: In]
		set;
	}

	public virtual extern tagSIZE Size
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		get;
	}

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	public virtual extern void PatBlt([MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagRECT prcDest, ref tagPOINT ptOrigin);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	public virtual extern void StretchBlt([MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagPOINT pptDest, int nWidth, int nStartStretch, int nEndStretch);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	public virtual extern void Blt(ref tagRECT rcSrc, [MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagPOINT pptDest);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	public virtual extern void StretchBltArea(ref tagRECT prcSrc, [MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagRECT prcDest);
}
